## widelands 1.2

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 3.12)
cmake_policy(VERSION 3.12)

project (widelands)

message(STATUS "Using CMake version ${CMAKE_VERSION}")

# Detailed help is in README.md
# Please update it if you change anything here
option(OPTION_USE_GLBINDING "Use glbinding instead of GLEW" OFF)
option(OPTION_GLEW_STATIC "Use static GLEW Library" OFF)
option(OPTION_BUILD_WEBSITE_TOOLS "Build website-related tools" ON)
option(OPTION_BUILD_TRANSLATIONS "Build translations" ON)
option(OPTION_BUILD_TESTS "Build tests" ON)
option(OPTION_BUILD_CODECHECK "Build codecheck" ON)
option(OPTION_BUILD_WINSTATIC "Build a static linked .exe on windows" OFF)
option(OPTION_TSAN "Build with ThreadSanitizer" OFF)
option(OPTION_FORCE_EMBEDDED_MINIZIP "Use embedded minizip sources" OFF)
option(USE_XDG "Follow XDG-Basedir specification" ON) # Enabled by default

set(CMAKE_FIND_FRAMEWORK LAST)

# Absolute path reference for submodules
set(WL_ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}")

# Add custom includes to override system libs
FILE(GLOB custom_include_directories auto_dependencies/*)
foreach(custom_include_dir ${custom_include_directories})
  if(IS_DIRECTORY "${custom_include_dir}")
    message(STATUS "Using custom include directory '${custom_include_dir}'.")
    list(INSERT CMAKE_INCLUDE_PATH 0 "${custom_include_dir}")
    include_directories(BEFORE SYSTEM "${custom_include_dir}")
  else()
    message(WARNING "Not a directory: '${custom_include_dir}' - Ignored.")
  endif()
endforeach()

include("${CMAKE_SOURCE_DIR}/cmake/UseSystemInfo.cmake")
include("${CMAKE_SOURCE_DIR}/cmake/WlFunctions.cmake")

# This policy is not known to versions prior 3.27 and would result in errors,
# if set on such systems. This can be removed when cmake_minimum_required is set
# to 3.27 or newer  by using:
# cmake_policy(VERSION 3.27)
if(POLICY CMP0148)
  cmake_policy(SET CMP0148 NEW)
endif(POLICY CMP0148)

IF(USE_XDG AND NOT APPLE AND NOT WIN32)
  ADD_DEFINITIONS(-DUSE_XDG)
  message(STATUS "Building with XDG support")
ENDIF(USE_XDG AND NOT APPLE AND NOT WIN32)

if (CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR)
  message(FATAL_ERROR "Build directory and source directory must not be the same.")
endif (CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR)

# Define the directory structure for installation - will be hardcoded in WL bin
# (through config.h). If not specified, we are going to use the directory where
# the executable is in. Also on Linux.
# Packagers (or people using make install) have to set this variable to an absolute path.
wl_set_if_unset(WL_INSTALL_BASEDIR ".")

# Define the directory structure for installation of the data files - will be hardcoded
# in WL bin (through config.h). If not specified, we are going to use the "data" directory
# below the directory where the executable is in. Also on Linux.
# Packagers (or people using make install) have to set this variable to an absolute path.
wl_set_if_unset(WL_INSTALL_DATADIR "./data")

# To override this, use '-DWL_INSTALL_BINDIR=<absolute path>' when configuring or change
# 'CMAKE_INSTALL_PREFIX'.
# Example: to have the bin installed to "/usr/games", just use '-DCMAKE_INSTALL_PREFIX=/usr'
# and don't specify '-DWL_INSTALL_BINDIR' when configuring.
# Note: 'CMAKE_INSTALL_PREFIX' defaults to /usr/local on UNIX and c:/Program Files/${PROJECT_NAME} on Windows
wl_set_if_unset(WL_INSTALL_BINDIR "${CMAKE_INSTALL_PREFIX}/games")

if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
  if (CMAKE_CXX_COMPILER_VERSION VERSION_LESS 4.8)
    message(FATAL_ERROR "Widelands needs GCC >= 4.8 to compile.")
  endif()
elseif("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang" OR "${CMAKE_CXX_COMPILER_ID}" STREQUAL "AppleClang")
  if (CMAKE_CXX_COMPILER_VERSION VERSION_LESS 3.4)
    message(FATAL_ERROR "Clang version must be at least 3.4!")
  endif()
elseif("${CMAKE_CXX_COMPILER_ID}" STREQUAL "MSVC")
  if (CMAKE_CXX_COMPILER_VERSION VERSION_LESS 3.4)
    message(FATAL_ERROR "MSVC version must be at least 19!")
  endif()
else()
  message(WARNING "You are using an unsupported compiler! Supported are Clang and GCC.")
endif()
message(STATUS "Picking up default CXX flags:
    - CMAKE_CXX_FLAGS='${CMAKE_CXX_FLAGS}'
    - CMAKE_CXX_FLAGS_RELEASE='${CMAKE_CXX_FLAGS_RELEASE}'
    - CMAKE_CXX_FLAGS_DEBUG='${CMAKE_CXX_FLAGS_DEBUG}'")

SET(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules)

if (WIN32)
  link_libraries(wsock32 ws2_32 bcrypt)
endif()
if (OPTION_BUILD_WINSTATIC)
  add_definitions(-DGLBINDING_STATIC_DEFINE -DNGHTTP2_STATICLIB)
  set (OPTION_GLEW_STATIC ON)
  if(MSVC)
    set(CMAKE_FIND_LIBRARY_SUFFIXES ".lib")
  else()
    set(CMAKE_FIND_LIBRARY_PREFIXES "lib")
    set(CMAKE_FIND_LIBRARY_SUFFIXES ".a")
  endif()
endif()

find_package (Python3 REQUIRED)

find_package(Gettext REQUIRED)
find_package(OpenGL REQUIRED)
find_package(PNG 1.6 REQUIRED)

find_package(SDL2 REQUIRED)
find_package(SDL2_image REQUIRED)
find_package(SDL2_mixer REQUIRED)
find_package(SDL2_ttf REQUIRED)
find_package(ZLIB REQUIRED)
if(${CMAKE_VERSION} VERSION_LESS 3.9.0)
    find_package(ICU_old REQUIRED)
else()
    find_package(ICU REQUIRED COMPONENTS uc dt)
endif()
if(OPTION_USE_GLBINDING)
  find_package(glbinding REQUIRED)
else()
  find_package(GLEW REQUIRED)
endif()

# Check that Asio is installed. Asio does not have (or need) a Find… CMake Module, so we "only" need to check if the header exists.
if(NOT asio_location OR asio_location STREQUAL "")
  unset(asio_location CACHE)
  find_path(asio_location "asio.hpp")
  if(asio_location)
    message(STATUS "Found Asio in '${asio_location}'.")
  else()
    message(FATAL_ERROR "Could NOT find Asio (missing: asio.hpp). Please run:\n./install-dependencies.sh\nwhich will attempt to install all missing dependencies automatically, or provide further instructions if this not supported on your system.")
  endif()
endif()
add_definitions(-DASIO_STANDALONE)

if (APPLE OR WIN32 OR
    CMAKE_SYSTEM_NAME MATCHES "FreeBSD" OR
    CMAKE_SYSTEM_NAME MATCHES "OpenBSD")
  if (NOT CMAKE_SYSTEM_NAME MATCHES "kFreeBSD")
    find_package(Intl REQUIRED)
  endif()
endif()

# Disable no symbols warning on macOS, but only on versions where this is
# supported. It is not supported on OS X 10.7 (DARWIN_MAJOR_VERSION == 11).
if (APPLE)
    if (${DARWIN_MAJOR_VERSION} GREATER 11)
        SET(CMAKE_C_ARCHIVE_CREATE   "<CMAKE_AR> Scr <TARGET> <LINK_FLAGS> <OBJECTS>")
        SET(CMAKE_CXX_ARCHIVE_CREATE "<CMAKE_AR> Scr <TARGET> <LINK_FLAGS> <OBJECTS>")
        SET(CMAKE_C_ARCHIVE_FINISH   "<CMAKE_RANLIB> -no_warning_for_no_symbols -c <TARGET>")
        SET(CMAKE_CXX_ARCHIVE_FINISH "<CMAKE_RANLIB> -no_warning_for_no_symbols -c <TARGET>")
    endif()
endif()

# TODO(sirver): One day, this should be enabled. Then we have no more cycles in our dependencies....
# set_property(GLOBAL PROPERTY GLOBAL_DEPENDS_NO_CYCLES ON)

if (NOT CMAKE_BUILD_TYPE OR CMAKE_BUILD_TYPE STREQUAL "")
  find_path(FILE_WL_RELEASE "WL_RELEASE" ${CMAKE_CURRENT_SOURCE_DIR})
  if(${FILE_WL_RELEASE} STREQUAL "FILE_WL_RELEASE-NOTFOUND")
    set(CMAKE_BUILD_TYPE Debug)
  else()
    set(CMAKE_BUILD_TYPE Release)
  endif()
endif (NOT CMAKE_BUILD_TYPE OR CMAKE_BUILD_TYPE STREQUAL "")

if(CMAKE_BUILD_TYPE STREQUAL "Debug")
  set(WL_DEBUG_FLAGS "-DDEBUG")
  if(NOT MSVC)
    wl_add_flag(WL_DEBUG_FLAGS "-g")
    if(NOT OPTION_TSAN)
      option(OPTION_ASAN "Build with AddressSanitizer" ON)
    endif()
  endif()
elseif((CMAKE_BUILD_TYPE STREQUAL "Release") OR (CMAKE_BUILD_TYPE STREQUAL "RelWithDebInfo"))
  if(("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU") AND (CMAKE_CXX_COMPILER_VERSION VERSION_GREATER 7.5))
    message(STATUS "GCC >7.5.0 breaks -O3, setting -O2")
    set(WL_OPTIMIZE_FLAGS "-O2")
  elseif(MSVC)
    set(WL_OPTIMIZE_FLAGS "/O2")
  else()
    set(WL_OPTIMIZE_FLAGS "-O3")
  endif()
  if(("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU") AND (CMAKE_CXX_COMPILER_VERSION VERSION_LESS 7.6))
    message(WARNING "GCC <7.6.0 is known to cause segfaults in release builds. Please consider upgrading to GCC version 7.6 or newer or using Clang. Adding selected overrides to suppress reporting of known bugs.")
    wl_add_flag(WL_OPTIMIZE_FLAGS "--param asan-stack=0")
  endif()
  set(WL_DEBUG_FLAGS "-DNDEBUG -DNOPARACHUTE")
  option(OPTION_ASAN "Build with AddressSanitizer" OFF)
elseif(CMAKE_BUILD_TYPE STREQUAL "None")
  message(STATUS "Not setting any default flags.")
else()
  message(FATAL_ERROR "Unknown CMAKE_BUILD_TYPE: ${CMAKE_BUILD_TYPE}")
endif()

if(OPTION_TSAN)
  message(STATUS "Using ThreadSanitizer https://clang.llvm.org/docs/ThreadSanitizer.html")
  wl_add_flag(WL_COMPILE_DIAGNOSTICS "-fsanitize=thread")
  set (CMAKE_EXE_LINKER_FLAGS "-fsanitize=thread" CACHE STRING "Set by widelands CMakeLists.txt" FORCE)
  option(OPTION_ASAN "Build with AddressSanitizer" OFF)
else()
  message(STATUS "Not using ThreadSanitizer.")
endif(OPTION_TSAN)

if(OPTION_ASAN)
  message(STATUS "Using AddressSanitizer https://clang.llvm.org/docs/AddressSanitizer.html")
  # See https://clang.llvm.org/docs/AddressSanitizer.html
  wl_add_flag(WL_COMPILE_DIAGNOSTICS "-fsanitize=address")
  wl_add_flag(WL_COMPILE_DIAGNOSTICS "-fno-omit-frame-pointer")
  set (CMAKE_EXE_LINKER_FLAGS "-fsanitize=address" CACHE STRING "Set by widelands CMakeLists.txt" FORCE)
  add_definitions(-DUSE_ASAN)
else()
  message(STATUS "Not using AddressSanitizer.")
endif(OPTION_ASAN)

if(OPTION_ASAN AND OPTION_TSAN)
  message(FATAL_ERROR "OPTION_ASAN and OPTION_TSAN cannot be used together")
endif()

# This is set to avoid linker errors when using GLVND-libs on Linux
if("${OpenGL_GL_PREFERENCE}" STREQUAL "GLVND")
   link_libraries(OpenGL::GL)
   add_compile_definitions(WL_USE_GLVND)
   message(STATUS "Adding linker flags for GLVND.")
endif()

if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
  set(warn_disable_flags
    "-Weverything"

    # Disabled warnings that are overly verbose right now or just do not make sense.
    "-Wno-c++98-compat"
    "-Wno-c++98-compat-pedantic"
    "-Wno-conversion"
    "-Wno-exit-time-destructors"
    "-Wno-global-constructors"
    "-Wno-padded"
    "-Wno-sign-conversion"
    "-Wno-missing-noreturn"

    # It is impossible to write code that both GCC and Clang will like,
    # so we have to switch off the warning for one of them.
    # http://clang-developers.42468.n3.nabble.com/Question-on-Wswitch-enum-td4025927.html
    "-Wno-switch-enum"

    # TODO(sirver: weak-vtables should be enabled, but leads to lot of errors right now.
    "-Wno-weak-vtables"
    "-Wno-unreachable-code"
    "-Wno-documentation"
    "-Qunused-arguments"
    "-Wint-to-void-pointer-cast"
  )
  foreach(flag IN LISTS warn_disable_flags)
    wl_add_flag(WL_COMPILE_DIAGNOSTICS ${flag})
  endforeach()

  if(CMAKE_CXX_COMPILER_VERSION VERSION_GREATER 3.8)
    wl_add_flag(WL_COMPILE_DIAGNOSTICS "-Winconsistent-missing-override")
  endif()
  if(CMAKE_CXX_COMPILER_VERSION VERSION_GREATER 16)
    wl_add_flag(WL_COMPILE_DIAGNOSTICS "-Wno-unsafe-buffer-usage")
  endif()
elseif(MSVC)
  wl_add_flag(WL_GENERIC_CXX_FLAGS "/std:c++17")
  # https://docs.microsoft.com/en-us/cpp/error-messages/compiler-warnings/
  # Disabled warnings that are overly verbose right now or just do not make sense.
  wl_add_flag(WL_COMPILE_DIAGNOSTICS "/wd4244")
  wl_add_flag(WL_COMPILE_DIAGNOSTICS "/wd4267")
  wl_add_flag(WL_COMPILE_DIAGNOSTICS "/wd4018")
  # Use correct code page
  wl_add_flag(WL_GENERIC_CXX_FLAGS "/utf-8")
else()
  # Assuming GCC 4.8 or higher.
  if(WIN32)
    # This is needed for getenv().
    wl_add_flag(WL_GENERIC_CXX_FLAGS "-std=gnu++17")
    if (OPTION_BUILD_WINSTATIC)
      set(CMAKE_CXX_STANDARD_LIBRARIES "-static-libgcc -static-libstdc++ ${CMAKE_CXX_STANDARD_LIBRARIES}")
      set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,-Bstatic")
    endif()
  else()
    # SDL and MinGW both declare 'unsigned int __builtin_ia32_crc32qi(unsigned int, unsigned char)', resulting in lots of warnings. So, we can't have this flag in Windows.
    wl_add_flag(WL_COMPILE_DIAGNOSTICS "-Wredundant-decls")
  endif()

=== src/CMakeLists.txt ===
configure_file (${CMAKE_CURRENT_SOURCE_DIR}/config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config.h)
configure_file (${CMAKE_CURRENT_SOURCE_DIR}/build_info.cc.cmake ${CMAKE_CURRENT_BINARY_DIR}/build_info.cc)
configure_file (${CMAKE_CURRENT_SOURCE_DIR}/../cmake/datadirversion.cmake ${CMAKE_CURRENT_SOURCE_DIR}/../data/datadirversion)

# Catchall target to codecheck all files.
add_custom_target(codecheck)
add_custom_target(run_build_deps
  COMMAND
    ${Python3_EXECUTABLE}
    ${CMAKE_SOURCE_DIR}/utils/build_deps.py
  COMMENT "Checking CMakeLists.txt files."
)
add_dependencies(codecheck run_build_deps)

# A target that depends on all unit tests as 'make test' will not rebuild
# tests:
# https://stackoverflow.com/questions/733475/cmake-ctest-make-test-doesnt-build-tests
add_custom_target(wl_tests)

#include the cmake version dependend macro _include_directories
if (CMAKE_VERSION VERSION_LESS 2.8.11)
  include (${CMAKE_SOURCE_DIR}/cmake/IncludeDirectoriesOld.cmake)
else (CMAKE_VERSION VERSION_LESS 2.8.11)
  include (${CMAKE_SOURCE_DIR}/cmake/IncludeDirectories.cmake)
endif (CMAKE_VERSION VERSION_LESS 2.8.11)

wl_library(build_info
  SRCS
    build_info.cc
    build_info.h
)

if (WIN32)
	configure_file (${CMAKE_CURRENT_SOURCE_DIR}/../utils/windows/widelands.rc.cmake ${CMAKE_CURRENT_BINARY_DIR}/widelands.rc)
	message (STATUS "Configured windows resource file")
	set(WIN32_ICON_O ${CMAKE_CURRENT_BINARY_DIR}/wl_icon.o)
	if(MSVC)
		ADD_CUSTOM_COMMAND(OUTPUT ${WIN32_ICON_O}
			COMMAND rc
				/fo ${WIN32_ICON_O}
				${CMAKE_CURRENT_BINARY_DIR}/widelands.rc
		)
	else()
		ADD_CUSTOM_COMMAND(OUTPUT ${WIN32_ICON_O}
			COMMAND ${MINGW_PREFIX}windres
				-o${WIN32_ICON_O}
				-i${CMAKE_CURRENT_BINARY_DIR}/widelands.rc
		)
	endif()

  wl_binary(widelands
    WIN32
    SRCS
      main.cc
      ${WIN32_ICON_O}
    DEPENDS
      base_exceptions
      widelands_ball_of_mud
      build_info
  )
else()
  wl_binary(widelands
    SRCS
      main.cc
    DEPENDS
      base_exceptions
      base_time_string
      logic_filesystem_constants
      widelands_ball_of_mud
      build_info
  )
endif()

if(OPTION_FORCE_EMBEDDED_MINIZIP)
    # unset these two if they are cached
    unset(MINIZIP_FOUND)
    set(MINIZIP_STATIC_LIBRARIES "")
else()
   # If pkg-config is ever needed to find other libraries, move the include outside the if() block
  include(FindPkgConfig)
  if(PKG_CONFIG_FOUND)
    pkg_check_modules(MINIZIP minizip)
  endif()
endif()

add_subdirectory(third_party)
add_subdirectory(ai)
add_subdirectory(base)
add_subdirectory(chat)
add_subdirectory(economy)
add_subdirectory(editor)
add_subdirectory(game_io)
add_subdirectory(graphic)
add_subdirectory(io)
add_subdirectory(logic)
add_subdirectory(map_io)
add_subdirectory(network)
add_subdirectory(notifications)
add_subdirectory(scripting)
add_subdirectory(sound)
add_subdirectory(ui_basic)
add_subdirectory(ui_fsmenu)
if (OPTION_BUILD_WEBSITE_TOOLS)
  add_subdirectory(website)
endif (OPTION_BUILD_WEBSITE_TOOLS)
add_subdirectory(wui)

# TODO(unknown): Ideally widelands_ball_of_mud shouldn't exist, everything should be in a
# library.
wl_library(widelands_ball_of_mud
  SRCS
    wlapplication.cc
    wlapplication.h
    wlapplication_messages.cc
    wlapplication_messages.h
  USES_ATOMIC
  USES_SDL2
  USES_SDL2_TTF
  DEPENDS
    base
    base_exceptions
    base_geometry
    base_macros
    base_random
    base_time_string
    build_info
    editor
    graphic
    graphic_fonthandler
    graphic_mouse_cursor
    graphic_text
    io_filesystem
    logic
    logic_addons
    logic_exceptions
    logic_filesystem_constants
    logic_game_controller
    logic_game_settings
    logic_map
    logic_single_player_game_settings
    map_io_map_loader
    network
    sound
    ui_basic
    ui_fsmenu
    widelands_options
    wui
    wui_chat_ui
    wui_common_mapdetails
)

wl_library(widelands_options
  SRCS
    wlapplication_options.cc
    wlapplication_options.h
    wlapplication_mousewheel_options.cc
    wlapplication_mousewheel_options.h
  DEPENDS
    base
    base_geometry
    graphic_text_layout
    io_filesystem
    io_profile
    logic_filesystem_constants
  USES_SDL2
)

if (CMAKE_SYSTEM_NAME MATCHES "FreeBSD" OR CMAKE_SYSTEM_NAME MATCHES "OpenBSD")
  target_link_libraries(widelands_ball_of_mud ${EXECINFO_LIBRARY})
endif (CMAKE_SYSTEM_NAME MATCHES "FreeBSD" OR CMAKE_SYSTEM_NAME MATCHES "OpenBSD")

if (WIN32)
  target_link_libraries(widelands_ball_of_mud wsock32)
#  set_target_properties(widelands PROPERTIES LINK_FLAGS_RELEASE -s)
endif (WIN32)

=== src/base/CMakeLists.txt ===
add_subdirectory(test)

wl_library(base
  SRCS
    format/abstract_node.h
    format/boolean_node.h
    format/common_nodes.h
    format/float_node.h
    format/number_node.h
    format/string_node.h
    format/tree.cc
    format/tree.h
    format/wildcard_node.h
    format/write_number.h
    i18n.h
    i18n.cc
    multithreading.h
    multithreading.cc
    mutex.h
    log.cc
    log.h
    string.h
    string.cc
  USES_ATOMIC
  USES_INTL
  USES_SDL2
  DEPENDS
    base_exceptions
    base_macros
    base_times
    build_info
    io_filesystem
    logic_filesystem_constants
    notifications
    third_party_gettext
)

wl_library(base_macros
  SRCS
    macros.h
    macros.cc
)

wl_library(base_exceptions
  SRCS
    exceptions.cc
    warning.h
    wexception.h
  DEPENDS
    base_macros
)

wl_library(base_utf8
  SRCS
    utf8.h
    utf8.cc
)

wl_library(base_geometry
  SRCS
    rect.h
    vector.h
    vector.cc
)

wl_library(base_md5
  SRCS
    md5.cc
    md5.h
  DEPENDS
    base_macros
)

wl_library(base_random
  SRCS
    random.h
    random.cc
  DEPENDS
    io_stream
    base_exceptions
)


wl_library(base_scoped_timer
  SRCS
    scoped_timer.h
    scoped_timer.cc
  USES_SDL2
  DEPENDS
    base
    base_macros
)


wl_library(base_time_string
  SRCS
    time_string.h
    time_string.cc
  DEPENDS
    base
)


wl_library(base_times
  SRCS
    times.h
    times.cc
  USES_ATOMIC
  DEPENDS
    base_exceptions
    io_fileread
)


wl_library(base_math
  SRCS
    math.h
    math.cc
  DEPENDS
    base_exceptions
)

wl_library(base_test
  SRCS
    test.h
    test.cc
  DEPENDS
    base
    base_exceptions
)

=== src/logic/CMakeLists.txt ===
wl_library(logic_exceptions
  SRCS
    game_data_error.cc
    game_data_error.h
  DEPENDS
    base
    base_exceptions
)

wl_library(logic_widelands_geometry
  SRCS
    widelands_geometry.cc
    widelands_geometry.h
)

wl_library(logic_widelands_geometry_io
  SRCS
    widelands_geometry_io.cc
    widelands_geometry_io.h
  DEPENDS
    io_fileread
    io_stream
    logic_constants
    logic_widelands_geometry
)

wl_library(logic_game_settings
  SRCS
    game_settings.cc
    game_settings.h
    player_end_result.h
  DEPENDS
    graphic_color
    io_filesystem
    logic_addons
    logic_constants
    logic_exceptions
    logic_filesystem_constants
    logic_tribe_basic_info
    notifications
    scripting_lua_interface
    scripting_lua_table
)

wl_library(logic_single_player_game_settings
  SRCS
    single_player_game_settings_provider.cc
    single_player_game_settings_provider.h
  DEPENDS
    ai
    base
    base_exceptions
    base_random
    graphic_playercolor
    logic_game_settings
    logic_tribe_basic_info
)

wl_library(logic_game_controller
  SRCS
    game_controller.h
    replay_game_controller.h
    replay_game_controller.cc
    single_player_game_controller.h
    single_player_game_controller.cc
  USES_SDL2
  DEPENDS
    ai
    base_times
    logic
    logic_commands
    logic_game_settings
    ui_basic
    widelands_options
    wui
)

wl_library(logic_constants
  SRCS
    vision.h
    widelands.cc
    widelands.h
  DEPENDS
    base_exceptions
)

wl_library(logic_filesystem_constants
  SRCS
    filesystem_constants.h
    filesystem_constants.cc
)

wl_library(logic_addons
  SRCS
    addons.cc
    addons.h
    mutable_addon.cc
    mutable_addon.h
  DEPENDS
    base
    base_exceptions
    base_math
    base_time_string
    build_info
    graphic
    graphic_text_layout
    io_fileread
    io_filesystem
    io_profile
    logic_filesystem_constants
    logic_map
    map_io
    map_io_map_loader
    widelands_options
)

wl_library(logic_objectives
  SRCS
    objective.cc
    objective.h
  DEPENDS
    base
)


wl_library(logic_generic_save_handler
  SRCS
    generic_save_handler.h
    generic_save_handler.cc
  DEPENDS
    base
    base_time_string
    io_filesystem
    logic_filesystem_constants
)

wl_library(logic_map
  SRCS
    cookie_priority_queue.h
    field.cc
    field.h
    map.cc
    map.h
    map_compassdir.cc
    map_compassdir.h
    map_revision.cc
    map_revision.h
    mapastar.cc
    mapastar.h
    mapdifferenceregion.cc
    mapdifferenceregion.h
    mapfringeregion.cc
    mapfringeregion.h
    maphollowregion.cc
    maphollowregion.h
    mapregion.h
    maptriangleregion.cc
    maptriangleregion.h
    nodecaps.h
    note_map_options.h
    path.cc
    path.h
    pathfield.cc
    pathfield.h
  USES_ATOMIC
  DEPENDS
    base
    base_exceptions
    base_macros
    base_scoped_timer
    build_info
    economy
    graphic
    graphic_playercolor
    io_fileread
    io_filesystem
    logic
    logic_addons
    logic_constants
    logic_exceptions
    logic_filesystem_constants
    logic_map_objects
    logic_objectives
    logic_widelands_geometry
    logic_widelands_geometry_io
    map_io_map_loader
    notifications
    wui_mapview_pixelconstants
)

wl_library(logic_commands
  SRCS
    cmd_calculate_statistics.cc
    cmd_calculate_statistics.h
    cmd_delete_message.cc
    cmd_delete_message.h
    cmd_incorporate.cc
    cmd_incorporate.h
    cmd_luacoroutine.cc
    cmd_luacoroutine.h
    cmd_luascript.cc
    cmd_luascript.h
    cmd_queue.cc
    cmd_queue.h
    queue_cmd_factory.cc
    queue_cmd_factory.h
    queue_cmd_ids.h
    playercommand.cc
    playercommand.h
  DEPENDS
    base
    base_exceptions
    base_macros
    base_times
    economy # TODO(GunChleoc): Circular dependency
    graphic_text_layout
    io_fileread
    io_stream
    logic # TODO(GunChleoc): Circular dependency
    logic_constants
    logic_exceptions
    logic_game_controller
    logic_map
    logic_map_objects
    logic_widelands_geometry_io
    map_io
    scripting_coroutine
    scripting_logic # TODO(GunChleoc): Circular dependency
    scripting_lua_table
    wui
)


wl_library(logic_training_wheels
  SRCS
    training_wheels.cc
    training_wheels.h
  DEPENDS
    base
    io_filesystem
    io_profile
    logic_filesystem_constants
    scripting_lua_table
    scripting_lua_interface
)

wl_library(logic
  SRCS
    ai_dna_handler.cc
    ai_dna_handler.h
    detected_port_space.cc
    detected_port_space.h
    editor_game_base.cc
    editor_game_base.h
    game.cc
    game.h
    message.h
    message_id.h
    message_queue.h
    player.cc
    player.h
    player_area.h
    playersmanager.cc
    playersmanager.h
    replay.cc
    replay.h
    save_handler.cc
    save_handler.h
    trade_agreement.h
  # TODO(sirver): Uses SDL2 only on WIN32 for a dirty hack.
  USES_SDL2
  USES_ATOMIC
  DEPENDS
    base
    base_exceptions
    base_macros
    base_md5
    base_random
    base_scoped_timer
    base_time_string
    base_times
    build_info
    economy
    game_io
    graphic
    graphic_color
    graphic_playercolor
    io_fileread
    io_filesystem
    io_profile
    io_stream
    logic_addons
    logic_commands
    logic_constants
    logic_exceptions
    logic_filesystem_constants
    logic_game_controller
    logic_game_settings
    logic_generic_save_handler
    logic_map
    logic_map_objects
    logic_tribe_basic_info
    logic_training_wheels
    logic_widelands_geometry
    map_io
    map_io_map_loader
    note_sound
    notifications
    scripting_logic # TODO(GunChleoc): Circular dependency
    scripting_lua_interface
    scripting_lua_table
    sound
    sound_constants
    ui_basic
    ui_basic_loading_message
    widelands_options
    wui # TODO(GunChleoc): Circular dependency
    wui_game_tips
)

add_subdirectory(map_objects)

=== src/network/CMakeLists.txt ===
wl_library(network
  SRCS
    bufferedconnection.cc
    bufferedconnection.h
    constants.h
    internet_gaming.cc
    internet_gaming.h
    internet_gaming_messages.cc
    internet_gaming_messages.h
    internet_gaming_protocol.h
    gameclient.cc
    gameclient.h
    gamehost.cc
    gamehost.h
    host_game_settings_provider.cc
    host_game_settings_provider.h
    net_addons.cc
    net_addons.h
    netclient_interface.h
    netclient.cc
    netclient.h
    netclientproxy.cc
    netclientproxy.h
    nethost_interface.h
    nethost.cc
    nethost.h
    nethostproxy.cc
    nethostproxy.h
    network.cc
    network.h
    network_gaming_messages.cc
    network_gaming_messages.h
    network_lan_promotion.cc
    network_lan_promotion.h
    network_player_settings_backend.cc
    network_player_settings_backend.h
    network_protocol.h
    relay_protocol.h
    participantlist.cc
    participantlist.h
  USES_SDL2
  DEPENDS
    ai
    base
    base_exceptions
    base_macros
    base_math
    base_md5
    base_random
    base_time_string
    build_info
    chat
    game_io
    graphic
    io_fileread
    io_filesystem
    io_stream
    logic
    logic_addons
    logic_commands
    logic_constants
    logic_filesystem_constants
    logic_game_controller
    logic_game_settings
    logic_tribe_basic_info
    map_io_map_loader
    notifications
    scripting_lua_interface
    scripting_lua_table
    third_party_sha1
    ui_basic
    ui_fsmenu
    widelands_ball_of_mud
    widelands_options
    wui
)

=== src/ui_fsmenu/CMakeLists.txt ===
add_subdirectory(addons)

wl_library(ui_fsmenu
  SRCS
    about.cc
    about.h
    campaigndetails.cc
    campaigndetails.h
    campaigns.cc
    campaigns.h
    campaign_select.cc
    campaign_select.h
    crash_report.cc
    crash_report.h
    helpwindow.cc
    helpwindow.h
    internet_lobby.cc
    internet_lobby.h
    keyboard_options.cc
    keyboard_options.h
    launch_game.cc
    launch_game.h
    launch_mpg.cc
    launch_mpg.h
    launch_spg.cc
    launch_spg.h
    loadgame.cc
    loadgame.h
    login_box.cc
    login_box.h
    mapdetailsbox.cc
    mapdetailsbox.h
    mapselect.cc
    mapselect.h
    main.cc
    main.h
    menu.h
    menu.cc
    mousewheel_options.cc
    mousewheel_options.h
    mousewheel_report.cc
    mousewheel_report.h
    multiplayersetupgroup.cc
    multiplayersetupgroup.h
    netsetup_lan.cc
    netsetup_lan.h
    options.cc
    options.h
    random_game.cc
    random_game.h
    scenariodetails.cc
    scenariodetails.h
    scenario_select.cc
    scenario_select.h
    singleplayerdropdown.cc
    singleplayerdropdown.h
    singleplayersetupbox.cc
    singleplayersetupbox.h
    tech_info.cc
    tech_info.h
    training_wheel_options.cc
    training_wheel_options.h
  DEPENDS
    ai
    base
    base_exceptions
    base_random
    base_time_string
    build_info
    editor
    graphic
    graphic_fonthandler
    graphic_mouse_cursor
    graphic_playercolor
    graphic_styles
    graphic_surface
    graphic_text
    graphic_text_layout
    io_fileread
    io_filesystem
    io_profile
    logic
    logic_addons
    logic_filesystem_constants
    logic_game_settings
    logic_game_controller
    logic_map
    logic_map_objects
    logic_single_player_game_settings
    logic_training_wheels
    logic_tribe_basic_info
    map_io_map_loader
    network
    scripting_coroutine
    scripting_lua_interface
    scripting_lua_table
    ui_basic
    sound
    third_party_sha1
    ui_addons
    widelands_ball_of_mud
    widelands_options
    wui
    wui_chat_ui
    wui_common_mapdetails
    wui_common_gamedetails
    wui_common_suggested_teams
    wui_sound_options
  USES_SDL2
)

=== src/ui_fsmenu/addons/CMakeLists.txt ===
wl_library(ui_addons
  SRCS
    contact.cc
    contact.h
    login_box.cc
    login_box.h
    manager.cc
    manager.h
    packager.cc
    packager.h
    packager_box.cc
    packager_box.h
    progress.cc
    progress.h
    remote_interaction.cc
    remote_interaction.h
    rows_ui.cc
    rows_ui.h
    screenshot_upload.cc
    screenshot_upload.h
  DEPENDS
    base_time_string
    scripting_lua_table
    logic_filesystem_constants
    logic_tribe_basic_info
    io_filesystem
    graphic_text_layout
    ui_basic
    third_party_sha1
    base
    io_filesystem_illegal_filename_check
    ui_fsmenu
    widelands_ball_of_mud
    io_profile
    base_exceptions
    logic
    widelands_options
    graphic_fonthandler
    logic_addons
    network
    graphic
    wui_common_mapdetails
)

=== debian/changelog ===
widelands (2:1.2-2) unstable; urgency=medium

  * d/p/md5-endianess: New patch from upstream to fix FTBFS on big
    endian architectures.

 -- Martin Quinson <mquinson@debian.org>  Sat, 08 Jun 2024 16:14:04 +0200

widelands (2:1.2-1) unstable; urgency=medium

  * New upstream version. From the upstream webpage:
    - UI Plugins are add-ons that can add more functionality to the
      user interface
    - Naval Warfare preview: Invade foreign coasts using warships!
      This is included as a preview feature and needs to be explicitly
      enabled in the game setup screen.
    - Soldier garrisons for ports and headquarters
    - Balancing changes to the Amazon economy
    - Fifth scenario for the Frisian campaign
    - More settings in the game setup screen, such as configurable
      durations for timed win conditions.
    - Diplomacy handling for the computer players
    - Stick pinned notes onto map fields to mark important points
    - Hyperlinks let you navigate within the encyclopedia and to the
      online help
    - Easy maps publishing inside the editor
    - High-resolution images for many more units
    - Accessibility enhancements for many user interface components
    - Expose more functionality to the add-ons and scenario scripting
      interface
    - Fixed many crashes and hangs and enhanced error handling
  * Drop d/p/dbg_symbols and pick RelWithDebInfo build type in CMake
    now that upstream #5943 is merged.
  * Drop d/p/gcc-13.patch that was cherry-picked from upstream.
  * d/p/RelWithDebInfo-no-error: new patch to remove -Werror and
    activate LTO with RelWithDebInfo.
  - Bump Standards-Version to 4.7.0 -- no changes needed.

 -- Martin Quinson <mquinson@debian.org>  Sun, 02 Jun 2024 01:10:09 +0200

=== debian/control ===
Source: widelands
Section: games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders:
  Martin Quinson <mquinson@debian.org>,
Standards-Version: 4.7.0
Build-Depends: debhelper-compat (= 13),
  cmake,
  libasio-dev,
  libminizip-dev,
  libboost-dev,
  libboost-regex-dev,
  libboost-test-dev,
  libboost-system-dev,
  libcurl4-gnutls-dev,
  libglew-dev,
  libmd-dev,
  libpng-dev,
  libsdl2-dev,
  libsdl2-image-dev,
  libsdl2-mixer-dev,
  libsdl2-ttf-dev,
  python3,
  zlib1g-dev
Vcs-Git: https://salsa.debian.org/games-team/widelands.git
Vcs-Browser: https://salsa.debian.org/games-team/widelands
Homepage: http://www.widelands.org/
Rules-Requires-Root: no

Package: widelands
Architecture: any
Depends: widelands-data (= ${source:Version}),
  ${shlibs:Depends},
  ${misc:Depends},
Description: fantasy real-time strategy game
 Widelands is a strategy game aiming for gameplay similar to Settlers II by
 BlueByte.
 .
 In this game, you start out on a small piece of land with nothing more than
 a few of useful resources. Using those, you can build yourself an empire
 with many thousands of inhabitants. On your way towards this goal, you will
 have to build up an economic infrastructure, explore the lands around you
 and face enemies who are trying to rule the world just like you do.

Package: widelands-data
Architecture: all
Depends: fonts-freefont-ttf,
  fonts-dejavu-core,
  fonts-dejavu-extra,
  fonts-hosny-amiri,
  fonts-nakula,
  fonts-wqy-microhei,
  culmus-fancy,
  ${misc:Depends}
Description: fantasy real-time strategy game (data files)
 This package contains the graphics and levels for Widelands.
 .
 Widelands is a strategy game aiming for gameplay similar to Settlers II by
 BlueByte.
 .
 In this game, you start out on a small piece of land with nothing more than
 a few of useful resources. Using those, you can build yourself an empire
 with many thousands of inhabitants. On your way towards this goal, you will
 have to build up an economic infrastructure, explore the lands around you
 and face enemies who are trying to rule the world just like you do.

=== debian/rules ===
#!/usr/bin/make -f

# Hardening flags
CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
CFLAGS:=$(shell dpkg-buildflags --get CFLAGS) $(CPPFLAGS)
CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS) $(CPPFLAGS)
LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)

%:
	dh $@ $(DH_ARGS) --buildsystem=cmake


override_dh_auto_configure:
	# Make sure we don't use the embedded minizip but the system one
	rm src/third_party/minizip/*
	# Actually configure the package
	CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" CPPFLAGS="$(CPPFLAGS)" CXXFLAGS="$(CXXFLAGS)" \
	  dh_auto_configure -Scmake -- \
		-DWL_INSTALL_BASEDIR=/usr/share/games/widelands \
		-DWL_INSTALL_BINDIR=games \
		-DWL_INSTALL_DATADIR=/usr/share/games/widelands/data \
		-DWL_INSTALL_PREFIX=/usr \
		-DOPTION_BUILD_WEBSITE_TOOLS=OFF \
		-DCMAKE_BUILD_TYPE=RelWithDebInfo

override_dh_auto_install:
	dh_auto_install --parallel
	# Take care of the fonts (use system-wide ones)
	# Not doing so would violate the Debian Policy, preventing the package to enter the official repositories
	ln -s /usr/share/fonts/opentype/fonts-hosny-amiri debian/tmp/usr/share/games/widelands/data/i18n/fonts/amiri
	ln -s /usr/share/fonts/truetype/dejavu debian/tmp/usr/share/games/widelands/data/i18n/fonts/DejaVu
	ln -s /usr/share/fonts/truetype/wqy debian/tmp/usr/share/games/widelands/data/i18n/fonts/MicroHei
	ln -s /usr/share/fonts/truetype/Nakula debian/tmp/usr/share/games/widelands/data/i18n/fonts
	rm -rf debian/tmp/usr/share/games/widelands/data/i18n/fonts/Culmus/
	ln -s /usr/share/fonts/truetype/culmus-fancy debian/tmp/usr/share/games/widelands/data/i18n/fonts/Culmus
	# Remove the licenses that are included in debian/copyright
	rm debian/tmp/usr/share/games/widelands/data/i18n/fonts/Widelands/LICENSE
	# The GPL-2 license is listed from the user interface, so dont kill it completely
	# (we cannot patch the user interface because that's in a translated text)
	if cmp --quiet debian/tmp/usr/share/games/widelands/COPYING /usr/share/common-licenses/GPL-2 ; then \
	  rm debian/tmp/usr/share/games/widelands/COPYING; \
	  cd debian/tmp/usr/share/games/widelands/ ; \
	  ln -s /usr/share/common-licenses/GPL-2 COPYING ; \
	else \
	  echo "Error: Licence file changed. Please check it out:"; \
	  diff -u debian/tmp/usr/share/games/widelands/COPYING /usr/share/common-licenses/GPL-2; \
	  exit 1; \
	fi
	# appdata (not sure whether renaming is important, but change d/widelands.install if you change it)
	mv debian/tmp/usr/share/metainfo/org.widelands.Widelands.appdata.xml debian/tmp/usr/share/metainfo/widelands.appdata.xml

override_dh_missing:
	dh_missing --fail-missing
